package require ::quartus::project

set need_to_close_project 0
set make_assignments 1

# Check that the right project is open
if {[is_project_open]} {
	if {[string compare $quartus(project) "de2_115"]} {
		puts "Project de2_115 is not open"
		set make_assignments 0
	}
} else {
	# Only open if not already open
	if {[project_exists de2_115]} {
		project_open -revision de2_115 de2_115
	} else {
		project_new -revision de2_115 de2_115
	}
	set need_to_close_project 1
}

# Make assignments
if {$make_assignments} {
	set_global_assignment -name FAMILY "Cyclone IV E"
	set_global_assignment -name DEVICE EP4CE115F29C7
	set_global_assignment -name EDA_SIMULATION_TOOL "ModelSim (VHDL)"
	set_global_assignment -name EDA_OUTPUT_DATA_FORMAT VHDL -section_id eda_simulation
	set_global_assignment -name USE_GENERATED_PHYSICAL_CONSTRAINTS OFF -section_id eda_blast_fpga
	set_global_assignment -name MISC_FILE "de2_115.dpf"
	set_global_assignment -name STRATIX_DEVICE_IO_STANDARD "3.3-V LVTTL"
	set_global_assignment -name RESERVE_ALL_UNUSED_PINS "AS INPUT TRI-STATED WITH WEAK PULL-UP"
	set_global_assignment -name RESERVE_ASDO_AFTER_CONFIGURATION "AS INPUT TRI-STATED"
	set_global_assignment -name CYCLONEII_RESERVE_NCEO_AFTER_CONFIGURATION "USE AS REGULAR IO"

	set_global_assignment -name TOP_LEVEL_ENTITY debounce_top
	set_global_assignment -name VHDL_FILE ../src/counter.vhd
	set_global_assignment -name VHDL_FILE ../src/counter_beh.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_fsm.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_fsm_beh.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_pkg.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_struct.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_tb.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_top.vhd
	set_global_assignment -name VHDL_FILE ../src/debounce_top_struct.vhd
	set_global_assignment -name VHDL_FILE ../src/event_counter.vhd
	set_global_assignment -name VHDL_FILE ../src/event_counter_beh.vhd
	set_global_assignment -name VHDL_FILE ../src/event_counter_pkg.vhd
	set_global_assignment -name VHDL_FILE ../src/math_pkg.vhd
	set_global_assignment -name VHDL_FILE ../src/sync.vhd
	set_global_assignment -name VHDL_FILE ../src/sync_beh.vhd
	set_global_assignment -name VHDL_FILE ../src/sync_pkg.vhd

	set_global_assignment -name SDC_FILE ../src/de2_115.sdc


	set_location_assignment PIN_AA17 -to seg_a[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[0]
	set_location_assignment PIN_AB16 -to seg_a[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[1]
	set_location_assignment PIN_AA16 -to seg_a[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[2]
	set_location_assignment PIN_AB17 -to seg_a[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[3]
	set_location_assignment PIN_AB15 -to seg_a[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[4]
	set_location_assignment PIN_AA15 -to seg_a[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[5]
	set_location_assignment PIN_AC17 -to seg_a[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_a[6]
	set_location_assignment PIN_AD17 -to seg_b[0]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[0]
	set_location_assignment PIN_AE17 -to seg_b[1]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[1]
	set_location_assignment PIN_AG17 -to seg_b[2]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[2]
	set_location_assignment PIN_AH17 -to seg_b[3]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[3]
	set_location_assignment PIN_AF17 -to seg_b[4]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[4]
	set_location_assignment PIN_AG18 -to seg_b[5]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[5]
	set_location_assignment PIN_AA14 -to seg_b[6]
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to seg_b[6]
	set_location_assignment PIN_Y2 -to sys_clk
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to sys_clk
	set_location_assignment PIN_M23 -to sys_res_n
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to sys_res_n
	set_location_assignment PIN_AB28 -to btn_a
	set_instance_assignment -name IO_STANDARD "3.3-V LVTTL" -to btn_a

	set_global_assignment -name LL_ROOT_REGION ON -section_id "Root Region"
	set_global_assignment -name LL_MEMBER_STATE LOCKED -section_id "Root Region"
	set_global_assignment -name PARTITION_NETLIST_TYPE SOURCE -section_id Top
	set_global_assignment -name PARTITION_COLOR 16764057 -section_id Top
	set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top

	# Commit assignments
	export_assignments

	# Close project
	if {$need_to_close_project} {
		project_close
	}
}
